/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.uytube.ui.lista;

import java.awt.Color;
import java.awt.event.ItemEvent;
import java.util.List;
import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.uytube.controladores.Fabrica;
import org.uytube.controladores.ICategoria;
import org.uytube.controladores.ILista;
import org.uytube.datatypes.DtLista;
import org.uytube.ui.PopUp;

/** @author toto */
public class AltaLista extends javax.swing.JInternalFrame {

  private final ILista iLista = Fabrica.getControllerOf(Fabrica.Controller.LISTA);
  private final ICategoria iCategoria = Fabrica.getControllerOf(Fabrica.Controller.CATEOGRIA);

  private void enableBtnListaParticular() {
    if (txtNombreListaP.getText().isEmpty() || txtNombreUsuario.getText().isEmpty()) {
      btnAceptar1.setEnabled(false);
      btnAceptar1.setBackground(Color.GRAY);
    } else {
      btnAceptar1.setEnabled(true);
      btnAceptar1.setBackground(new Color(0, 123, 64));
    }
  }

  /** Creates new form AltaLista */
  public AltaLista() {
    initComponents();
    List<String> categorias = iCategoria.listarCategorias();
    cmbCategorias.addItem("");
    for (String categoria : categorias) {
      cmbCategorias.addItem(categoria);
    }
    btnAceptar.setEnabled(false);
    btnAceptar.setBackground(Color.GRAY);
    btnAceptar1.setEnabled(false);
    btnAceptar1.setBackground(Color.GRAY);
    panelParticular.setVisible(false);
    txtNombreLista
        .getDocument()
        .addDocumentListener(
            new DocumentListener() {
              @Override
              public void insertUpdate(DocumentEvent arg0) {
                update();
              }

              @Override
              public void removeUpdate(DocumentEvent arg0) {
                update();
              }

              @Override
              public void changedUpdate(DocumentEvent arg0) {
                update();
              }

              private void update() {
                if (txtNombreLista.getText().isEmpty()) {
                  btnAceptar.setEnabled(false);
                  btnAceptar.setBackground(Color.GRAY);
                } else {
                  btnAceptar.setEnabled(true);
                  btnAceptar.setBackground(new Color(0, 123, 64));
                }
              }
            });

    txtNombreUsuario
        .getDocument()
        .addDocumentListener(
            new DocumentListener() {
              @Override
              public void insertUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }

              @Override
              public void removeUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }

              @Override
              public void changedUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }
            });

    txtNombreListaP
        .getDocument()
        .addDocumentListener(
            new DocumentListener() {
              @Override
              public void insertUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }

              @Override
              public void removeUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }

              @Override
              public void changedUpdate(DocumentEvent arg0) {
                enableBtnListaParticular();
              }
            });
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT
   * modify this code. The content of this method is always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel3 = new javax.swing.JPanel();
    lblTitle = new javax.swing.JLabel();
    tabDefecto = new javax.swing.JPanel();
    jLabel2 = new javax.swing.JLabel();
    tabParticular = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    panelDefecto = new javax.swing.JPanel();
    jSeparator6 = new javax.swing.JSeparator();
    jSeparator7 = new javax.swing.JSeparator();
    jLabel4 = new javax.swing.JLabel();
    txtNombreLista = new javax.swing.JTextField();
    btnAceptar = new javax.swing.JButton();
    btnCancelar = new javax.swing.JButton();
    panelParticular = new javax.swing.JPanel();
    jSeparator8 = new javax.swing.JSeparator();
    jLabel5 = new javax.swing.JLabel();
    jSeparator9 = new javax.swing.JSeparator();
    jSeparator11 = new javax.swing.JSeparator();
    jRadioButton1 = new javax.swing.JRadioButton();
    jRadioButton2 = new javax.swing.JRadioButton();
    txtNombreUsuario = new javax.swing.JTextField();
    txtNombreListaP = new javax.swing.JTextField();
    btnCancelar1 = new javax.swing.JButton();
    btnAceptar1 = new javax.swing.JButton();
    cmbCategorias = new javax.swing.JComboBox<>();
    jLabel6 = new javax.swing.JLabel();
    jLabel9 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();

    setBorder(null);
    setClosable(true);
    setIconifiable(true);
    setTitle("Alta Lista");
    setMinimumSize(new java.awt.Dimension(439, 437));
    setPreferredSize(new java.awt.Dimension(439, 437));
    getContentPane().setLayout(null);

    jPanel3.setBackground(new java.awt.Color(246, 246, 246));
    jPanel3.setLayout(null);

    lblTitle.setFont(new java.awt.Font("Monospaced", 0, 24)); // NOI18N
    lblTitle.setForeground(new java.awt.Color(53, 12, 87));
    lblTitle.setText("Alta Lista");
    jPanel3.add(lblTitle);
    lblTitle.setBounds(140, 20, 140, 29);

    tabDefecto.setBackground(new java.awt.Color(53, 47, 91));
    tabDefecto.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    tabDefecto.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            tabDefectoMouseClicked(evt);
          }
        });
    tabDefecto.setLayout(null);

    jLabel2.setFont(new java.awt.Font("Monospaced", 1, 12)); // NOI18N
    jLabel2.setForeground(new java.awt.Color(255, 255, 255));
    jLabel2.setText("Lista Por Defecto");
    tabDefecto.add(jLabel2);
    jLabel2.setBounds(10, 10, 120, 15);

    jPanel3.add(tabDefecto);
    tabDefecto.setBounds(40, 70, 140, 30);

    tabParticular.setBackground(new java.awt.Color(66, 58, 111));
    tabParticular.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    tabParticular.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            tabParticularMouseClicked(evt);
          }
        });
    tabParticular.setLayout(null);

    jLabel1.setFont(new java.awt.Font("Monospaced", 1, 12)); // NOI18N
    jLabel1.setForeground(new java.awt.Color(255, 255, 255));
    jLabel1.setText("Lista Particular");
    tabParticular.add(jLabel1);
    jLabel1.setBounds(10, 5, 120, 15);

    jPanel3.add(tabParticular);
    tabParticular.setBounds(180, 75, 130, 25);

    panelDefecto.setBackground(new java.awt.Color(255, 255, 255));
    panelDefecto.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
    panelDefecto.setLayout(null);
    panelDefecto.add(jSeparator6);
    jSeparator6.setBounds(30, 50, 290, 10);
    panelDefecto.add(jSeparator7);
    jSeparator7.setBounds(50, 120, 150, 20);

    jLabel4.setFont(new java.awt.Font("Monospaced", 1, 14)); // NOI18N
    jLabel4.setForeground(new java.awt.Color(33, 33, 33));
    jLabel4.setText("Datos de Lista Por Defecto");
    panelDefecto.add(jLabel4);
    jLabel4.setBounds(30, 30, 210, 17);

    txtNombreLista.setForeground(new java.awt.Color(60, 63, 65));
    txtNombreLista.setBorder(
        javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1),
            "Nombre *",
            javax.swing.border.TitledBorder.LEADING,
            javax.swing.border.TitledBorder.DEFAULT_POSITION,
            new java.awt.Font("Monospaced", 0, 12))); // NOI18N
    panelDefecto.add(txtNombreLista);
    txtNombreLista.setBounds(50, 85, 150, 37);

    btnAceptar.setBackground(new java.awt.Color(0, 123, 64));
    btnAceptar.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnAceptar.setForeground(new java.awt.Color(255, 255, 255));
    btnAceptar.setText("Aceptar");
    btnAceptar.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnAceptar.setContentAreaFilled(false);
    btnAceptar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnAceptar.setEnabled(false);
    btnAceptar.setOpaque(true);
    btnAceptar.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnAceptarMouseClicked(evt);
          }
        });
    panelDefecto.add(btnAceptar);
    btnAceptar.setBounds(50, 200, 110, 40);

    btnCancelar.setBackground(new java.awt.Color(255, 50, 40));
    btnCancelar.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnCancelar.setForeground(new java.awt.Color(255, 255, 255));
    btnCancelar.setText("Cancelar");
    btnCancelar.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnCancelar.setContentAreaFilled(false);
    btnCancelar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnCancelar.setOpaque(true);
    btnCancelar.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnCancelarMouseClicked(evt);
          }
        });
    panelDefecto.add(btnCancelar);
    btnCancelar.setBounds(190, 200, 110, 40);

    jPanel3.add(panelDefecto);
    panelDefecto.setBounds(40, 100, 350, 260);

    panelParticular.setBackground(new java.awt.Color(255, 255, 255));
    panelParticular.setBorder(
        new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
    panelParticular.setLayout(null);
    panelParticular.add(jSeparator8);
    jSeparator8.setBounds(30, 50, 290, 10);

    jLabel5.setFont(new java.awt.Font("Monospaced", 1, 14)); // NOI18N
    jLabel5.setForeground(new java.awt.Color(33, 33, 33));
    jLabel5.setText("Datos Lista Particular");
    panelParticular.add(jLabel5);
    jLabel5.setBounds(30, 30, 180, 17);
    panelParticular.add(jSeparator9);
    jSeparator9.setBounds(40, 170, 120, 10);
    panelParticular.add(jSeparator11);
    jSeparator11.setBounds(40, 110, 120, 10);

    jRadioButton1.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
    jRadioButton1.setText("Privada");
    jRadioButton1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    jRadioButton1.addItemListener(this::jRadioButton1ItemStateChanged);
    panelParticular.add(jRadioButton1);
    jRadioButton1.setBounds(260, 140, 90, 30);

    jRadioButton2.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
    jRadioButton2.setSelected(true);
    jRadioButton2.setText("Publica");
    jRadioButton2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    jRadioButton2.addItemListener(this::jRadioButton2ItemStateChanged);
    panelParticular.add(jRadioButton2);
    jRadioButton2.setBounds(180, 140, 90, 30);

    txtNombreUsuario.setForeground(new java.awt.Color(60, 63, 65));
    txtNombreUsuario.setBorder(
        javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1),
            "Nickname *",
            javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
            javax.swing.border.TitledBorder.DEFAULT_POSITION,
            new java.awt.Font("Monospaced", 0, 12))); // NOI18N
    panelParticular.add(txtNombreUsuario);
    txtNombreUsuario.setBounds(40, 72, 120, 40);

    txtNombreListaP.setForeground(new java.awt.Color(60, 63, 65));
    txtNombreListaP.setBorder(
        javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1),
            "Nombre *",
            javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
            javax.swing.border.TitledBorder.DEFAULT_POSITION,
            new java.awt.Font("Monospaced", 0, 12))); // NOI18N
    panelParticular.add(txtNombreListaP);
    txtNombreListaP.setBounds(40, 132, 120, 40);

    btnCancelar1.setBackground(new java.awt.Color(255, 50, 40));
    btnCancelar1.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnCancelar1.setForeground(new java.awt.Color(255, 255, 255));
    btnCancelar1.setText("Cancelar");
    btnCancelar1.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnCancelar1.setContentAreaFilled(false);
    btnCancelar1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnCancelar1.setOpaque(true);
    btnCancelar1.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnCancelar1MouseClicked(evt);
          }
        });
    panelParticular.add(btnCancelar1);
    btnCancelar1.setBounds(190, 200, 110, 40);

    btnAceptar1.setBackground(new java.awt.Color(0, 123, 64));
    btnAceptar1.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnAceptar1.setForeground(new java.awt.Color(255, 255, 255));
    btnAceptar1.setText("Aceptar");
    btnAceptar1.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnAceptar1.setContentAreaFilled(false);
    btnAceptar1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnAceptar1.setEnabled(false);
    btnAceptar1.setOpaque(true);
    btnAceptar1.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnAceptar1MouseClicked(evt);
          }
        });
    panelParticular.add(btnAceptar1);
    btnAceptar1.setBounds(50, 200, 110, 40);

    cmbCategorias.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    panelParticular.add(cmbCategorias);
    cmbCategorias.setBounds(190, 87, 130, 30);

    jLabel6.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
    jLabel6.setForeground(new java.awt.Color(0, 0, 0));
    jLabel6.setText("Categoria");
    panelParticular.add(jLabel6);
    jLabel6.setBounds(190, 72, 70, 15);

    jPanel3.add(panelParticular);
    panelParticular.setBounds(40, 100, 350, 260);

    jLabel9.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/logo.png"))); // NOI18N
    jPanel3.add(jLabel9);
    jLabel9.setBounds(350, 366, 30, 40);

    jLabel8.setFont(new java.awt.Font("Monospaced", 1, 12)); // NOI18N
    jLabel8.setForeground(new java.awt.Color(255, 255, 255));
    jLabel8.setText("UyTube");
    jPanel3.add(jLabel8);
    jLabel8.setBounds(378, 380, 50, 20);

    jLabel3.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/formBackground.jpg"))); // NOI18N
    jPanel3.add(jLabel3);
    jLabel3.setBounds(130, 180, 310, 240);

    getContentPane().add(jPanel3);
    jPanel3.setBounds(0, 0, 440, 420);

    setBounds(292, 162, 439, 437);
  } // </editor-fold>//GEN-END:initComponents

  private void btnAceptarMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnAceptarMouseClicked
    if (btnAceptar.isEnabled()) {
      JFrame frame = (JFrame) getDesktopPane().getTopLevelAncestor();
      try {
        iLista.altaListaDefecto(txtNombreLista.getText());
        this.dispose();
        new PopUp(frame, "Alta Lista", "Se creo la Lista", 5, PopUp.LEVEL.SUCCESS);
      } catch (IllegalArgumentException e) {
        new PopUp(frame, "Alta Lista", e.getMessage(), 5, PopUp.LEVEL.ERROR);
      }
    }
  } // GEN-LAST:event_btnAceptarMouseClicked

  private void btnCancelarMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnCancelarMouseClicked
    dispose();
  } // GEN-LAST:event_btnCancelarMouseClicked

  private void btnCancelar1MouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnCancelar1MouseClicked
    dispose();
  } // GEN-LAST:event_btnCancelar1MouseClicked

  private void btnAceptar1MouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnAceptar1MouseClicked
    if (btnAceptar1.isEnabled()) {
      JFrame frame = (JFrame) getDesktopPane().getTopLevelAncestor();
      try {
        DtLista dtLista;
        if (cmbCategorias.getSelectedIndex() == 0) {
          dtLista = new DtLista(txtNombreListaP.getText(), jRadioButton1.isSelected());
        } else {
          dtLista =
              new DtLista(
                  txtNombreListaP.getText(),
                  jRadioButton1.isSelected(),
                  cmbCategorias.getSelectedItem().toString());
        }
        iLista.altaListaParticular(txtNombreUsuario.getText(), dtLista);
        this.dispose();
        new PopUp(frame, "Alta Lista", "Se creo la Lista", 5, PopUp.LEVEL.SUCCESS);
      } catch (IllegalArgumentException e) {
        new PopUp(frame, "Alta Lista", e.getMessage(), 5, PopUp.LEVEL.ERROR);
      }
    }
  } // GEN-LAST:event_btnAceptar1MouseClicked

  private void jRadioButton2ItemStateChanged(
      java.awt.event.ItemEvent evt) { // GEN-FIRST:event_jRadioButton2ItemStateChanged
    if (evt.getStateChange() == ItemEvent.SELECTED) {
      jRadioButton1.setSelected(false);

    } else if (evt.getStateChange() == ItemEvent.DESELECTED) {
      jRadioButton1.setSelected(true);
    }
  } // GEN-LAST:event_jRadioButton2ItemStateChanged

  private void jRadioButton1ItemStateChanged(
      java.awt.event.ItemEvent evt) { // GEN-FIRST:event_jRadioButton1ItemStateChanged
    if (evt.getStateChange() == ItemEvent.SELECTED) {
      jRadioButton2.setSelected(false);

    } else if (evt.getStateChange() == ItemEvent.DESELECTED) {
      jRadioButton2.setSelected(true);
    }
  } // GEN-LAST:event_jRadioButton1ItemStateChanged

  private void tabDefectoMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_tabDefectoMouseClicked
    tabDefecto.setBackground(new Color(53, 47, 91));
    tabDefecto.setBounds(40, 70, 140, 30);
    tabParticular.setBounds(180, 75, 130, 25);
    tabParticular.setBackground(new Color(66, 58, 111));
    jLabel2.setLocation(10, 7);
    panelDefecto.setVisible(true);
    panelParticular.setVisible(false);
  } // GEN-LAST:event_tabDefectoMouseClicked

  private void tabParticularMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_tabParticularMouseClicked
    tabParticular.setBackground(new Color(53, 47, 91));
    tabParticular.setBounds(180, 70, 130, 30);
    tabDefecto.setBounds(40, 75, 140, 25);
    tabDefecto.setBackground(new Color(66, 58, 111));
    jLabel1.setLocation(10, 7);
    jLabel2.setLocation(10, 7);
    panelParticular.setVisible(true);
    panelDefecto.setVisible(false);
  } // GEN-LAST:event_tabParticularMouseClicked

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton btnAceptar;
  private javax.swing.JButton btnAceptar1;
  private javax.swing.JButton btnCancelar;
  private javax.swing.JButton btnCancelar1;
  private javax.swing.JComboBox<String> cmbCategorias;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JRadioButton jRadioButton1;
  private javax.swing.JRadioButton jRadioButton2;
  private javax.swing.JSeparator jSeparator11;
  private javax.swing.JSeparator jSeparator6;
  private javax.swing.JSeparator jSeparator7;
  private javax.swing.JSeparator jSeparator8;
  private javax.swing.JSeparator jSeparator9;
  private javax.swing.JLabel lblTitle;
  private javax.swing.JPanel panelDefecto;
  private javax.swing.JPanel panelParticular;
  private javax.swing.JPanel tabDefecto;
  private javax.swing.JPanel tabParticular;
  private javax.swing.JTextField txtNombreLista;
  private javax.swing.JTextField txtNombreListaP;
  private javax.swing.JTextField txtNombreUsuario;
  // End of variables declaration//GEN-END:variables
}
